function varargout = DesignBasic(varargin)
% DESIGNBASIC M-file for DesignBasic.fig
%      DESIGNBASIC, by itself, creates a new DESIGNBASIC or raises the existing
%      singleton*.
%
%      H = DESIGNBASIC returns the handle to a new DESIGNBASIC or the handle to
%      the existing singleton*.
%
%      DESIGNBASIC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DESIGNBASIC.M with the given input arguments.
%
%      DESIGNBASIC('Property','Value',...) creates a new DESIGNBASIC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before DesignBasic_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to DesignBasic_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help DesignBasic

% Last Modified by GUIDE v2.5 27-Apr-2012 19:53:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @DesignBasic_OpeningFcn, ...
    'gui_OutputFcn',  @DesignBasic_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before DesignBasic is made visible.
function DesignBasic_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to DesignBasic (see VARARGIN)

% Choose default command line output for DesignBasic
handles.output = hObject;

% Draw FIGURE HERE
handles.successful = 0;

handles.NLayers = varargin{1};
handles.D = varargin{2};
if nargin>6
    handles.Vary = varargin{3};
    handles.Stat = varargin{4};
    handles.A = varargin{5}*100;
    handles.L = varargin{6};
    handles.W = varargin{7};
    handles.V = varargin{8};
    handles.LP = varargin{9};
else
    if handles.D == 1
        handles.Vary = [1E3 1E9; 0.01 10];
        handles.Stat = ones(2,handles.NLayers);
        handles.L = 1;
        handles.W = 1;
    else
        handles.Vary = [1E4 1E8; 1E-4 1E-2];
        handles.Stat = repmat([1E6 ; 1E-3],1,handles.NLayers);
        handles.L = 100e-6;
        handles.W = 100e-6;
    end
    handles.A = zeros(handles.NLayers,1);
    handles.V = ones(handles.NLayers,1);
    handles.LP = varargin{3};
end

if handles.D == 0
    set(handles.ETxt,'String','Young''s modulus');
    set(handles.TTxt,'String','Thickness');
    set(handles.LengthTxt,'String','Length');
    set(handles.Length,'enable','off');
    set(handles.WidthTxt,'String','Width');
    set(handles.Width,'enable','off');
else
    set(handles.ScalingToggle,'enable','off');
end
set(handles.YesVary,'Value',handles.V(1));
set(handles.NoVary,'Value',1-handles.V(1));
set(handles.alpha,'String',num2str(handles.A(1,1)));
handles.Scaling = 0;
handles.EVaryV = 1;
handles.TVaryV = 1;

if handles.V(1) == 1
    set(handles.Emin,'String',num2str(handles.Vary(1,1)));
    set(handles.Emax,'String',num2str(handles.Vary(1,2)));
    set(handles.Tmin,'String',num2str(handles.Vary(2,1)));
    set(handles.Tmax,'String',num2str(handles.Vary(2,2)));
else
    set(handles.Emin,'String',num2str(handles.Stat(1,1)));
    set(handles.Emax,'String',num2str(handles.Stat(1,1)));
    set(handles.Tmin,'String',num2str(handles.Stat(2,1)));
    set(handles.Tmax,'String',num2str(handles.Stat(2,1)));
    set(handles.Emax,'Visible','off');
    set(handles.Tmax,'Visible','off');
    set(handles.MaxTxt,'Visible','off');
    set(handles.MinTxt,'Visible','off');
    set(handles.TVary,'Enable','off');
    set(handles.EVary,'Enable','off');
end

LayerList = cell(1,handles.NLayers);
handles.LayerChoice = 1;

for i = 1:handles.NLayers
    handles.rec(i) = rectangle('Position',[0 (i-1)*1 1 1],'LineWidth',4,'Parent',handles.DeviceV);
    text(-0.1,0.1+(i-1),strcat({'Layer  '},num2str(i)),'Rotation',90,'FontWeight','Bold','FontSize',12,'Parent',handles.DeviceV)
    
    text(0.05,0.8+(i-1),'Modulus','FontWeight','Bold','FontSize',12,'Parent',handles.DeviceV)
    text(0.05,0.45+(i-1),'to','Parent',handles.DeviceV)
    text(0.4,0.8+(i-1),'Thickness','FontWeight','Bold','FontSize',12,'Parent',handles.DeviceV)
    text(0.4,0.45+(i-1),'to','Parent',handles.DeviceV)
    
    if handles.V(i) == 1
        handles.e1(i) = text(0.05,0.6+(i-1),num2str(handles.Vary(1,1),'%-1G'),'Parent',handles.DeviceV);
        handles.e2(i) = text(0.05,0.30+(i-1),num2str(handles.Vary(1,2),'%-1G'),'Parent',handles.DeviceV);
        handles.t1(i) = text(0.4,0.6+(i-1),num2str(handles.Vary(2,1),'%-1G'),'Parent',handles.DeviceV);
        handles.t2(i) = text(0.4,0.30+(i-1),num2str(handles.Vary(2,2),'%-1G'),'Parent',handles.DeviceV);
    else
        handles.e1(i) = text(0.05,0.6+(i-1),num2str(handles.Stat(1,i),'%-1G'),'Parent',handles.DeviceV);
        handles.e2(i) = text(0.05,0.30+(i-1),num2str(handles.Stat(1,i),'%-1G'),'Parent',handles.DeviceV);
        handles.t1(i) = text(0.4,0.6+(i-1),num2str(handles.Stat(2,i),'%-1G'),'Parent',handles.DeviceV);
        handles.t2(i) = text(0.4,0.30+(i-1),num2str(handles.Stat(2,i),'%-1G'),'Parent',handles.DeviceV);
    end
    
    text(0.75,0.8+(i-1),'Strain','FontWeight','Bold','FontSize',12,'Parent',handles.DeviceV)
    handles.a1(i) = text(0.75,0.6+(i-1),strcat(num2str(handles.A(i,1)),{'%'}),'Parent',handles.DeviceV);
    
    if handles.A(i,1) ~= 0
        set(handles.rec(i),'FaceColor',[0.85 0.85 0.85]);
    else
        set(handles.rec(i),'FaceColor',[1 1 1]);
    end
    
    LayerList(i) = strcat({'Layer '},num2str(i));
end

set(handles.LayerList,'String',LayerList);
axis(handles.DeviceV,[-0.2 1.1 -0.3 i*1+0.3],'off')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes DesignBasic wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = DesignBasic_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.Vary;
varargout{2} = handles.Stat;
varargout{3} = handles.A*0.01;
varargout{4} = handles.L;
varargout{5} = handles.W;
varargout{6} = handles.V;
varargout{7} = handles.successful;
varargout{8} = handles.Scaling;
if sum(handles.V)==0
    varargout{9} = 1;
else
    varargout{9} = handles.EVaryV+handles.TVaryV+1;
end
varargout{10} = handles.DeviceV;
if handles.successful == 0
    close
end


% --- Executes on selection change in LayerList.
function LayerList_Callback(hObject, eventdata, handles)
% hObject    handle to LayerList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.LayerChoice = get(hObject,'Value');

set(handles.YesVary,'Value',handles.V(handles.LayerChoice));
set(handles.NoVary,'Value',1-handles.V(handles.LayerChoice));
set(handles.alpha,'String',num2str(handles.A(handles.LayerChoice,1)));


if handles.V(handles.LayerChoice) == 1
    set(handles.Emin,'String',num2str(handles.Vary(1,1)));
    set(handles.Emax,'String',num2str(handles.Vary(1,2)));
    set(handles.Tmin,'String',num2str(handles.Vary(2,1)));
    set(handles.Tmax,'String',num2str(handles.Vary(2,2)));
    if handles.EVaryV == 1
        set(handles.Emax,'Visible','on');
    else
        set(handles.Emax,'Visible','off');
    end
    if handles.TVaryV == 1
        set(handles.Tmax,'Visible','on');
    else
        set(handles.Tmax,'Visible','off');
    end
    set(handles.MaxTxt,'Visible','on');
    set(handles.MinTxt,'Visible','on');
    set(handles.TVary,'Enable','on');
    set(handles.EVary,'Enable','on');
else
    set(handles.Emin,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Emax,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Tmin,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Tmax,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Emax,'Visible','off');
    set(handles.Tmax,'Visible','off');
    set(handles.MaxTxt,'Visible','off');
    set(handles.MinTxt,'Visible','off');
    set(handles.TVary,'Enable','off');
    set(handles.EVary,'Enable','off');
end

guidata(hObject, handles);
% Hints: contents = get(hObject,'String') returns LayerList contents as cell array
%        contents{get(hObject,'Value')} returns selected item from LayerList


% --- Executes during object creation, after setting all properties.
function LayerList_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LayerList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Emin_Callback(hObject, eventdata, handles)
% hObject    handle to Emin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.V(handles.LayerChoice) == 1
    for i = 1:handles.NLayers
        if handles.V(i) == 1
            set(handles.e1(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
            if handles.EVaryV == 0
                set(handles.e2(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
            end
        end
    end
    handles.Vary(1,1) = str2double(get(hObject,'String'));
    if handles.EVaryV == 0
        handles.Vary(1,2) = str2double(get(hObject,'String'));
%         set(handles.Emax,'String',get(hObject,'String'));
    end
else
    set(handles.e1(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    handles.Stat(1,handles.LayerChoice) = str2double(get(hObject,'String'));
end

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Emin as text
%        str2double(get(hObject,'String')) returns contents of Emin as a double


% --- Executes during object creation, after setting all properties.
function Emin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Emin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Emax_Callback(hObject, eventdata, handles)
% hObject    handle to Emax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.V(handles.LayerChoice) == 1
    for i = 1:handles.NLayers
        if handles.V(i) == 1
            set(handles.e2(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
        end
    end
    handles.Vary(1,2) = str2double(get(hObject,'String'));
else
    set(handles.e1(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    handles.Stat(1,handles.LayerChoice) = str2double(get(hObject,'String'));
end

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Emax as text
%        str2double(get(hObject,'String')) returns contents of Emax as a double


% --- Executes during object creation, after setting all properties.
function Emax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Emax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Tmin_Callback(hObject, eventdata, handles)
% hObject    handle to Tmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.V(handles.LayerChoice) == 1
    for i = 1:handles.NLayers
        if handles.V(i) == 1
            set(handles.t1(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
            if handles.TVaryV == 0
                set(handles.t2(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
            end
        end
    end
    handles.Vary(2,1) = str2double(get(hObject,'String'));
    if handles.TVaryV == 0
        handles.Vary(2,2) = str2double(get(hObject,'String'));
%         set(handles.Tmax,'String',get(hObject,'String'));
    end
else
    set(handles.t1(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    handles.Stat(2,handles.LayerChoice) = str2double(get(hObject,'String'));
end

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Tmin as text
%        str2double(get(hObject,'String')) returns contents of Tmin as a double


% --- Executes during object creation, after setting all properties.
function Tmin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tmin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Tmax_Callback(hObject, eventdata, handles)
% hObject    handle to Tmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.V(handles.LayerChoice) == 1
    for i = 1:handles.NLayers
        if handles.V(i) == 1
            set(handles.t2(i),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
        end
    end
    handles.Vary(2,2) = str2double(get(hObject,'String'));
else
    set(handles.t1(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(str2double(get(hObject,'String')),'%-1G'),'EraseMode','xor');
    handles.Stat(2,handles.LayerChoice) = str2double(get(hObject,'String'));
end

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Tmax as text
%        str2double(get(hObject,'String')) returns contents of Tmax as a double


% --- Executes during object creation, after setting all properties.
function Tmax_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Tmax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function alpha_Callback(hObject, eventdata, handles)
% hObject    handle to alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.a1(handles.LayerChoice),'String',strcat(get(hObject,'String'),{'%'}),'EraseMode','xor');
handles.A(handles.LayerChoice,1) = str2double(get(hObject,'String'));

if handles.A(handles.LayerChoice,1) ~= 0
    set(handles.rec(handles.LayerChoice),'FaceColor',[0.85 0.85 0.85]);
else
    set(handles.rec(handles.LayerChoice),'FaceColor',[1 1 1]);
end

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of alpha as text
%        str2double(get(hObject,'String')) returns contents of alpha as a double


% --- Executes during object creation, after setting all properties.
function alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Length_Callback(hObject, eventdata, handles)
% hObject    handle to Length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.L = str2double(get(hObject,'String'));

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Length as text
%        str2double(get(hObject,'String')) returns contents of Length as a double


% --- Executes during object creation, after setting all properties.
function Length_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Length (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Width_Callback(hObject, eventdata, handles)
% hObject    handle to Width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.W = str2double(get(hObject,'String'));

guidata(hObject, handles);
% Hints: get(hObject,'String') returns contents of Width as text
%        str2double(get(hObject,'String')) returns contents of Width as a double


% --- Executes during object creation, after setting all properties.
function Width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ContinueB.
function ContinueB_Callback(hObject, eventdata, handles)
% hObject    handle to ContinueB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if sum(1-handles.V)>0
    if sum(abs(handles.A)) == 0
        strainbut = questdlg('Device does not have at least one layer with strain. Do you wish to continue?','No Strain','Yes','No','No');
        if strcmp(strainbut,'Yes')
            handles.successful = 1;
            guidata(hObject, handles);
            uiresume(handles.figure1)
        end
    else
        handles.successful = 1;
        guidata(hObject, handles);
        uiresume(handles.figure1)
    end
else
    errordlg('All layers are varying. You must select at least one layer to stay constant.')
end


% --- Executes on button press in RestartB.
function RestartB_Callback(hObject, eventdata, handles)
% hObject    handle to RestartB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.successful = 0;
guidata(hObject, handles);
uiresume(handles.figure1)


% --- Executes during object creation, after setting all properties.
function YesVary_CreateFcn(hObject, eventdata, handles)
% hObject    handle to YesVary (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in LayerVaryG.
function LayerVaryG_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in LayerVaryG
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if strcmp(get(eventdata.NewValue,'Tag'),'YesVary')
    handles.V(handles.LayerChoice) = 1;
    set(handles.Emin,'String',num2str(handles.Vary(1,1)));
    set(handles.Emax,'String',num2str(handles.Vary(1,2)));
    set(handles.Tmin,'String',num2str(handles.Vary(2,1)));
    set(handles.Tmax,'String',num2str(handles.Vary(2,2)));
    if handles.TVaryV == 1
        set(handles.Tmax,'Visible','on');
    else
        set(handles.Tmax,'Visible','off');
    end
    if handles.EVaryV == 1
        set(handles.Emax,'Visible','on');
    else
        set(handles.Emax,'Visible','off');
    end
    set(handles.MaxTxt,'Visible','on');
    set(handles.MinTxt,'Visible','on');
    set(handles.TVary,'Enable','on');
    set(handles.EVary,'Enable','on');
    set(handles.e1(handles.LayerChoice),'String',num2str(handles.Vary(1,1),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(handles.Vary(1,2),'%-1G'),'EraseMode','xor');
    set(handles.t1(handles.LayerChoice),'String',num2str(handles.Vary(2,1),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(handles.Vary(2,2),'%-1G'),'EraseMode','xor');
else
    handles.V(handles.LayerChoice) = 0;
    set(handles.Emin,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Emax,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Tmin,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Tmax,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Emax,'Visible','off');
    set(handles.Tmax,'Visible','off');
    set(handles.MaxTxt,'Visible','off');
    set(handles.MinTxt,'Visible','off');
    set(handles.TVary,'Enable','off');
    set(handles.EVary,'Enable','off');
    set(handles.e1(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t1(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
end

guidata(hObject, handles);


% --- Executes on button press in ScalingToggle.
function ScalingToggle_Callback(hObject, eventdata, handles)
% hObject    handle to ScalingToggle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.Scaling = get(hObject,'Value');

guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of ScalingToggle


% --- Executes on button press in EVary.
function EVary_Callback(hObject, eventdata, handles)
% hObject    handle to EVary (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.EVaryV = get(hObject,'Value');
if handles.TVaryV+handles.EVaryV == 0
    set(handles.EVary,'Value',1);
    handles.EVaryV = 1;
    set(handles.YesVary,'Value',0);
    set(handles.NoVary,'Value',1);
    handles.V(handles.LayerChoice) = 0;
    set(handles.Emin,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Emax,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Tmin,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Tmax,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Emax,'Visible','off');
    set(handles.Tmax,'Visible','off');
    set(handles.MaxTxt,'Visible','off');
    set(handles.MinTxt,'Visible','off');
    set(handles.TVary,'Enable','off');
    set(handles.EVary,'Enable','off');
    set(handles.e1(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t1(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
else
    if handles.EVaryV == 1
        set(handles.Emax,'Visible','on');
        handles.Vary(1,2) = str2double(get(handles.Emax,'String'));
        set(handles.e2(handles.LayerChoice),'String',get(handles.Emax,'String'));
    else
        set(handles.Emax,'Visible','off');
        handles.Vary(1,2) = str2double(get(handles.Emin,'String'));
        set(handles.e2(handles.LayerChoice),'String',get(handles.Emin,'String'));
    end
end
guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of EVary


% --- Executes on button press in TVary.
function TVary_Callback(hObject, eventdata, handles)
% hObject    handle to TVary (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.TVaryV = get(hObject,'Value');
if handles.TVaryV+handles.EVaryV == 0
    set(handles.TVary,'Value',1);
    handles.TVaryV = 1;
    set(handles.YesVary,'Value',0);
    set(handles.NoVary,'Value',1);
    handles.V(handles.LayerChoice) = 0;
    set(handles.Emin,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Emax,'String',num2str(handles.Stat(1,handles.LayerChoice)));
    set(handles.Tmin,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Tmax,'String',num2str(handles.Stat(2,handles.LayerChoice)));
    set(handles.Emax,'Visible','off');
    set(handles.Tmax,'Visible','off');
    set(handles.MaxTxt,'Visible','off');
    set(handles.MinTxt,'Visible','off');
    set(handles.TVary,'Enable','off');
    set(handles.EVary,'Enable','off');
    set(handles.e1(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.e2(handles.LayerChoice),'String',num2str(handles.Stat(1,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t1(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
    set(handles.t2(handles.LayerChoice),'String',num2str(handles.Stat(2,handles.LayerChoice),'%-1G'),'EraseMode','xor');
else
    if handles.TVaryV == 1
        set(handles.Tmax,'Visible','on');
        handles.Vary(2,2) = str2double(get(handles.Tmax,'String'));
        set(handles.t2(handles.LayerChoice),'String',get(handles.Tmax,'String'));
    else
        set(handles.Tmax,'Visible','off');
        handles.Vary(2,1) = str2double(get(handles.Tmin,'String'));
        set(handles.t2(handles.LayerChoice),'String',get(handles.Tmin,'String'));
    end
end

guidata(hObject, handles);
% Hint: get(hObject,'Value') returns toggle state of TVary


% --- Executes on button press in SaveButt.
function SaveButt_Callback(hObject, eventdata, handles)
% hObject    handle to SaveButt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%%
LayerE = zeros(handles.NLayers,2);
LayerT = zeros(handles.NLayers,2);
LayerW = zeros(handles.NLayers,1);

% Create matrices from output data from GUI to pass into
% 'PlotMultilayerModel.m'
for i = 1:handles.NLayers
    if handles.V(i) == 1
        LayerE(i,:) = handles.Vary(1,:);
        LayerT(i,:) = handles.Vary(2,:);
    else
        LayerE(i,:) = [handles.Stat(1,i) handles.Stat(1,i)];
        LayerT(i,:) = [handles.Stat(2,i) handles.Stat(2,i)];
    end
    LayerW(i) = handles.W;
end
LayerS = handles.A*0.01;
DeviceL = handles.L;
options.ND = handles.Scaling;
options.LV = handles.V;
if sum(handles.V)==0
    options.DIM = 1;
else
    options.DIM = handles.EVaryV+handles.TVaryV+1;
end
options.D = handles.D;
NLayers = handles.NLayers;
LayerP = handles.LP;
options.n = 2;
options.ttag = char(strcat({'CUSTOM MODEL ('},num2str(NLayers),{' LAYERS)'}));
            

uisave({'LayerE','LayerT','LayerS','LayerW','DeviceL','LayerP','NLayers','options'},'Bender1')
